VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_PointNum As Integer
Private m_x(0 To 2)
Private m_y(0 To 2)

Private Sub FindCircle(ByVal ax As Single, ByVal ay As Single, ByVal bx As Single, ByVal by As Single, ByVal cx As Single, ByVal cy As Single, ByRef ox As Single, ByRef oy As Single, ByRef radius As Single)
Dim x1 As Single
Dim y1 As Single
Dim dx1 As Single
Dim dy1 As Single
Dim x2 As Single
Dim y2 As Single
Dim dx2 As Single
Dim dy2 As Single
Dim dx As Single
Dim dy As Single

    ' Get the perpendicular bisector of (x1, y1) and (x2, y2).
    x1 = (bx + ax) / 2
    y1 = (by + ay) / 2
    dy1 = bx - ax
    dx1 = -(by - ay)

    ' Get the perpendicular bisector of (x2, y2) and (x3, y3).
    x2 = (cx + bx) / 2
    y2 = (cy + by) / 2
    dy2 = cx - bx
    dx2 = -(cy - by)

    ' See where the lines intersect.
    ox = (y1 * dx1 * dx2 + x2 * dx1 * dy2 - x1 * dy1 * dx2 - y2 * dx1 * dx2) _
        / (dx1 * dy2 - dy1 * dx2)
    oy = (ox - x1) * dy1 / dx1 + y1

    dx = ox - ax
    dy = oy - ay
    radius = Sqr(dx * dx + dy * dy)
End Sub
Private Sub Form_Load()
    AutoRedraw = True
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Const GAP = 10

Dim cx As Single
Dim cy As Single
Dim radius As Single

    m_x(m_PointNum) = X
    m_y(m_PointNum) = Y

    If m_PointNum = 0 Then
        ' Erase the form.
        Line (0, 0)-Step(ScaleWidth, ScaleHeight), BackColor, BF
    End If

    ' Draw the point.
    Line (X - GAP, Y - GAP)-(X + GAP, Y + GAP), vbBlack, BF

    If m_PointNum = 2 Then
        m_PointNum = 0

        ' Draw the circle.
        On Error Resume Next
        FindCircle m_x(0), m_y(0), _
            m_x(1), m_y(1), m_x(2), m_y(2), _
            cx, cy, radius
        If Err.Number <> 0 Then
            MsgBox "No circle"
        Else
            Circle (cx, cy), radius
        End If
    Else
        m_PointNum = m_PointNum + 1
    End If
End Sub
